import {jsx,jsxs,Fragment}from'react/jsx-runtime';import {Calendar,momentLocalizer}from'react-big-calendar';import withDragAndDrop from'react-big-calendar/lib/addons/dragAndDrop';import moment from'moment';import {AiOutlineDelete}from'@react-icons/all-files/ai/AiOutlineDelete';import {AiOutlineSchedule}from'@react-icons/all-files/ai/AiOutlineSchedule';import TimezonePicker from'react-timezone';import {Row,Col,Form,Select,Input,Button,Popconfirm,DatePicker}from'antd';import {Modal}from'../Modal.js';import {css}from'@emotion/css';const { RangePicker } = DatePicker;
const DnDCalendar = withDragAndDrop(Calendar);
const localizer = momentLocalizer(moment);
const allViews = ['agenda', 'day', 'week', 'month'];
function SelectableCalendar({ localizer, handleAddScheduleEvent, handleUpdateScheduleEvent, events, showModal, handleOpenModal, handleCloseModal, loading, form, selectedEvent, handleSelectEvent, selectedUser, handleChangeUser, handleRemoveEvent, handleSelectSlot, }) {
    const resetModal = (e) => {
        e.preventDefault();
        form.resetFields();
    };
    const onEventDrop = ({ event, start, end, allDay }) => {
        const updateRequest = {
            start,
            end,
            allDay,
        };
        handleUpdateScheduleEvent(event.id, updateRequest);
    };
    const onEventResize = ({ event, start, end }) => {
        const updateRequest = {
            start,
            end,
        };
        handleUpdateScheduleEvent(event.id, updateRequest);
    };
    const EventComponent = ({ start, end, title }) => {
        return (jsxs(Fragment, { children: [jsx("p", { children: title }), jsx("p", { children: start }), jsx("p", { children: end })] }));
    };
    const EventAgenda = ({ event }) => {
        return (jsxs("span", { children: [jsx("em", { style: { color: 'magenta' }, children: event.title }), jsx("p", { children: event.desc })] }));
    };
    const onFinish = values => {
        const request = {
            title: values.title,
            start: moment(values.dateRange[0]).toDate(),
            end: moment(values.dateRange[1]).toDate(),
            userId: values.user,
        };
        if (selectedEvent !== -1)
            handleUpdateScheduleEvent(selectedEvent, request);
        else
            handleAddScheduleEvent(request);
    };
    const renderModalBody = () => {
        return (jsx(Fragment, { children: jsxs(Form, { labelCol: { span: 24 }, wrapperCol: { span: 24 }, layout: "vertical", onFinish: onFinish, form: form, children: [jsx(Form.Item, { label: "Title", name: "title", rules: [{ required: true, message: 'Required field' }], children: jsx(Input, {}) }), jsx(Form.Item, { label: "User", name: "user", rules: [{ required: true, message: 'Required field' }], children: jsxs(Select, { children: [jsx(Select.Option, { value: "1", children: "User1" }), jsx(Select.Option, { value: "2", children: "User2" })] }) }), jsx(Form.Item, { label: "RangePicker", name: "dateRange", rules: [{ required: true, message: 'Required field' }], children: jsx(RangePicker, { allowClear: true, showTime: true }) }), jsx(Form.Item, { label: "Minimum Hours", name: "minHours", children: jsx(Input, { name: "minhours", placeholder: "5" }) }), jsx(Form.Item, { label: "Repeats", name: "repeats", children: jsxs(Select, { children: [jsx(Select.Option, { value: "never", children: "Never" }), jsx(Select.Option, { value: "yes", children: "Yes" })] }) }), jsxs(Form.Item, { children: [jsx(Button, { htmlType: "button", onClick: resetModal, children: "Reset" }), "\u00A0", jsx(Button, { type: "primary", htmlType: "submit", loading: loading, children: "Submit" }), "\u00A0", selectedEvent !== -1 ? (jsx(Popconfirm, { title: "Are you sure to remove event", okText: "OK", cancelText: "Cancel", onConfirm: handleRemoveEvent, children: jsx(Button, { type: "primary", htmlType: "button", loading: loading, icon: jsx(AiOutlineDelete, { style: { fontSize: 'large' } }), danger: true, children: "Remove" }) })) : ('')] })] }) }));
    };
    return (jsxs(Fragment, { children: [jsx(Row, { align: "middle", justify: "space-between", style: { marginBottom: '15px' }, children: jsx(Col, { children: jsx("div", { style: { textAlign: 'center' }, children: jsx("h3", { children: "Attendance schedules" }) }) }) }), jsxs(Row, { align: "middle", gutter: [24, 16], children: [jsxs(Col, { md: 6, xs: 16, style: { top: '-10px' }, children: [jsx("span", { children: "Select Timezone" }), jsx(TimezonePicker, { value: "Asia/Yerevan", onChange: timezone => console.log('New Timezone Selected:', timezone), inputProps: {
                                    placeholder: 'Select Timezone...',
                                    name: 'timezone',
                                } })] }), jsx(Col, { md: 6, xs: 16, children: jsx(Form, { labelCol: { span: 20 }, wrapperCol: { span: 20 }, layout: "vertical", className: "sm-screen-size", children: jsx(Form.Item, { label: "Members", children: jsxs(Select, { onChange: handleChangeUser, value: selectedUser, children: [jsx(Select.Option, { value: "", children: "All" }), jsx(Select.Option, { value: "1", children: "User1" }), jsx(Select.Option, { value: "2", children: "User2" })] }) }) }) }), jsx(Col, { md: 6, xs: 16, children: jsx("div", { className: "vertical-", children: jsxs("a", { href: "#", children: [jsx("span", { children: jsx(AiOutlineSchedule, { style: { fontSize: 'large' } }) }), ' ', "schedule settings"] }) }) }), jsx(Col, { md: 6, xs: 16, children: jsxs("div", { children: [jsx("span", { style: { fontWeight: 'bold' }, children: jsx("a", { onClick: handleOpenModal, children: "Add Schedule" }) }), jsx(Modal, { modalTitle: selectedEvent !== -1 ? 'Edit Schedule' : 'Create Schedule', showModal: showModal, handleClose: handleCloseModal, modalBody: renderModalBody() })] }) })] }), jsx(DnDCalendar, { selectable: true, localizer: localizer, events: events, defaultView: "month", views: allViews, defaultDate: new Date(), onSelectEvent: handleSelectEvent, onSelectSlot: handleSelectSlot, startAccessor: "start", endAccessor: "end", titleAccessor: "title", toolbar: true, resizable: true, onEventDrop: onEventDrop, onEventResize: onEventResize, components: {
                    event: EventComponent,
                    agenda: {
                        event: EventAgenda,
                    },
                } })] }));
}
function Schedule(props) {
    return (jsx("div", { className: css(stylesheet.styles), children: jsx("div", { className: "calender-width", children: jsx(SelectableCalendar, { localizer: localizer, ...props }) }) }));
}
const stylesheet = {
    styles: {
        position: 'relative',
        width: '100%',
        // Default height for the Calender Scheduler view
        '& .rbc-calendar': {
            height: '100vh',
        },
        '& .sm-screen-size': {
            '@media (max-width: 768px)': {
                width: '100% !important',
            },
        },
        '& ul.jsx-4179805763': {
            zIndex: 1050,
            webkitBoxSizing: 'border-box',
            boxSizing: 'border-box',
            padding: '4px 0',
            fontSize: '13px',
            maxHeight: '100px',
            fontVariant: 'initial',
            backgroundColor: '#fff',
            borderRadius: '2px',
            outline: 'none',
            webkitBoxShadow: '0 3px 6px -4px rgba(0, 0, 0, 0.12), 0 6px 16px 0 rgba(0, 0, 0, 0.08), 0 9px 28px 8px rgba(0, 0, 0, 0.05)',
            boxShadow: '0 3px 6px -4px rgba(0, 0, 0, 0.12), 0 6px 16px 0 rgba(0, 0, 0, 0.08), 0 9px 28px 8px rgba(0, 0, 0, 0.05)',
        },
        '& div.jsx-4179805763': {
            marginTop: '8px',
            width: '100%',
        },
    },
};export{Schedule as default};//# sourceMappingURL=Scheduler.js.map
